#include <algorithm>
#include <cmath>
#include <cstdio>

using namespace std;

int prva_grupa;
int n;
int k;
int a[100000];
int niz[100000];
int gdje[100000];

int cmp( int x, int y ) { return a[x] < a[y]; }

struct node {
   int val;
   int prev;
   int next;
} nodovi[100000];

struct grupa {
   int prvi, zadnji;
   int obrnuto;
   int pozicija;

   int prev;
   int next;
} grupe[10000];

int br_grupa;

void napravi() {
   int last_node = -1;
   int last_grupa = -1;
   int curr_grupa = -1;
   br_grupa = 0;
   
   prva_grupa = 0;

   int cnt = k-1;
   for( int i = 0; i < n; ++i ) {
      nodovi[i].val = a[i];
      nodovi[i].next = -1;
      nodovi[i].prev = last_node;      
      if( last_node != -1 ) nodovi[last_node].next = i;

      if( ++cnt == k ) {
         cnt = 0;
         curr_grupa = br_grupa++;
         grupe[curr_grupa].prvi = grupe[curr_grupa].zadnji = i;
         grupe[curr_grupa].obrnuto = 0;

         grupe[curr_grupa].next = -1;
         grupe[curr_grupa].prev = last_grupa;

         grupe[curr_grupa].pozicija = i;
         if( last_grupa != -1 ) grupe[last_grupa].next = curr_grupa;

         last_grupa = curr_grupa;
      }

      gdje[nodovi[i].val] = curr_grupa;
      grupe[curr_grupa].zadnji = i;
      
      last_node = i;
   }
}

void traverse() {
   int pos = 0;

   int g = prva_grupa;
   int curr = grupe[g].prvi;

   while( g != -1 ) {
      while( curr != grupe[g].zadnji ) {
         a[pos++] = nodovi[curr].val;
         if( grupe[g].obrnuto )
            curr = nodovi[curr].prev;
         else 
            curr = nodovi[curr].next;
      }
      a[pos++] = nodovi[curr].val;
      curr = nodovi[curr].next;
      
      g = grupe[g].next;
   }
}

void razjebi_i_ispisi( int g, int vrijednost ) {
   int ret = grupe[g].pozicija;

   int curr = grupe[g].prvi;
   while( nodovi[curr].val != vrijednost ) {
      if( grupe[g].obrnuto )
         curr = nodovi[curr].prev;
      else 
         curr = nodovi[curr].next;
      ++ret;
   }
   
   printf( "%d", ret+1 );

   if( curr == grupe[g].zadnji ) return;

   int nova = br_grupa++;
   grupe[nova].prev = g;
   grupe[nova].next = grupe[g].next;
   grupe[nova].obrnuto = grupe[g].obrnuto;

   grupe[nova].prvi = nodovi[curr].next;
   grupe[nova].zadnji = grupe[g].zadnji;

   grupe[g].zadnji = curr;

   if( grupe[g].obrnuto )
      curr = nodovi[curr].prev;
   else 
      curr = nodovi[curr].next;
   while( curr != grupe[g].zadnji ) {
      gdje[nodovi[curr].val] = g;
      if( grupe[g].obrnuto )
         curr = nodovi[curr].prev;
      else 
         curr = nodovi[curr].next;
   }
   gdje[nodovi[curr].val] = g;
}

int grupice[10000];
int size[10000];

void obrni( int zadnja_grupa ) {
   int g = prva_grupa;

   int mm = 0;
   while( g != zadnja_grupa ) {
      size[mm] = grupe[grupe[g].next].pozicija - grupe[g].pozicija;

      grupice[mm++] = g;
      
      g = grupe[g].next;
   }
   int iza = grupe[g].next;
   if( iza == -1 ) size[mm] = n - grupe[g].pozicija;
   else size[mm] = grupe[grupe[g].next].pozicija - grupe[g].pozicija;
   grupice[mm++] = g;

   int running = 0;
   for( int i = mm-1; i >= 0; --i ) {
      g = grupice[i];
      grupe[g].pozicija = running;
      running += size[ g ];
      
      swap( grupe[g].prvi, grupe[g].zadnji );
      grupe[g].obrnuto ^= 1;
   }
   return;

   prva_grupa = grupice[mm-1];
   nodovi[grupe[prva_grupa].prvi].prev = -1;

   int gg;
   for( int i = mm-1; i >= 0; --i ) {
      g = grupice[i];
      if( i > 0 ) gg = grupice[i-1];
      else gg = iza;
      
      nodovi[grupe[g].zadnji].next = grupe[gg].prvi;
      if( gg != -1 ) nodovi[grupe[gg].zadnji].prev = grupe[g].zadnji;
   }
}

int main( void ) {
   while( scanf( "%d", &n ) == 1 ) {
      if( n == 0 ) break;

      for( int i = 0; i < n; ++i ) { 
         scanf( "%d", &a[i] );
         niz[i] = i;
      }      
      
      k = min( max( 1, (int)sqrt( (double)n ) + 1), n);

      stable_sort( niz, niz+n, cmp );
      
      for( int i = 0; i < n; ++i ) a[niz[i]] = i;
      
      napravi();

      int cnt = 0;
      for( int i = 0; i < n; ++i ) {
         if( ++cnt == k ) {
            cnt = 0;
            traverse();
            napravi();
         }

         if( i ) printf( " " );

         int g = gdje[i];

         razjebi_i_ispisi( g, i );
         
         obrni( g );
      }
      printf( "\n" );

      /*
      printf( "Nodovi!\n" );
      for( int i = 0; i < n; ++i ) {
         printf( "%d  %d %d   grupa=%d\n", nodovi[i].val, nodovi[i].prev, nodovi[i].next, gdje[nodovi[i].val] );
      }
      printf( "Grupe!\n" );
      for( int i = 0; i < br_grupa; ++i ) {
         printf( "%d %d  %d  %d %d\n", grupe[i].prvi, grupe[i].zadnji, grupe[i].obrnuto, grupe[i].prev, grupe[i].next );
      }
      */
   }
   return 0;
}
